#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file Hanabigenerator.py
 @brief ModuleDescription
 @date $Date$


"""
import sys
import time
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist
import math


# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>

# This module's spesification
# <rtc-template block="module_spec">
hanabigenerator_spec = ["implementation_id", "Hanabigenerator", 
		 "type_name",         "Hanabigenerator", 
		 "description",       "ModuleDescription", 
		 "version",           "1.0.0", 
		 "vendor",            "VenderName", 
		 "category",          "Category", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

##
# @class Hanabigenerator
# @brief ModuleDescription
# 
# 
class Hanabigenerator(OpenRTM_aist.DataFlowComponentBase):
	#X = 0.0	
	#Y = 0.0	
	#Distance = 0.0	
	##
	# @brief constructor
	# @param manager Maneger Object
	# 
	Distance = 0.0
	X = 0.0
	Y = 0.0
	Theta = 0.0

	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_trigger = RTC.TimedDouble(RTC.Time(0,0),0)
		"""
		"""
		self._triggerIn = OpenRTM_aist.InPort("trigger", self._d_trigger)
		self._d_C_Poz1 = RTC.TimedPose2D(RTC.Time(0,0),RTC.Pose2D(RTC.Point2D(0,0), 0))
		"""
		"""
		self._C_Poz1In = OpenRTM_aist.InPort("C_Poz1", self._d_C_Poz1)
		self._d_C_Poz2 = RTC.TimedPose2D(RTC.Time(0,0),RTC.Pose2D(RTC.Point2D(0,0), 0))
		"""
		"""
		self._C_Poz2In = OpenRTM_aist.InPort("C_Poz2", self._d_C_Poz2)
		self._d_C_Poz3 = RTC.TimedPose2D(RTC.Time(0,0),RTC.Pose2D(RTC.Point2D(0,0), 0))
		"""
		"""
		self._C_Poz3In = OpenRTM_aist.InPort("C_Poz3", self._d_C_Poz3)
		self._d_C_Poz4 = RTC.TimedPose2D(RTC.Time(0,0),RTC.Pose2D(RTC.Point2D(0,0), 0))
		"""
		"""
		self._C_Poz4In = OpenRTM_aist.InPort("C_Poz4", self._d_C_Poz4)
		self._d_C_Poz5 = RTC.TimedPose2D(RTC.Time(0,0),RTC.Pose2D(RTC.Point2D(0,0), 0))
		"""
		"""
		self._C_Poz5In = OpenRTM_aist.InPort("C_Poz5", self._d_C_Poz5)
		self._d_C_Poz6 = RTC.TimedPose2D(RTC.Time(0,0),RTC.Pose2D(RTC.Point2D(0,0), 0))
		"""
		"""
		self._C_Poz6In = OpenRTM_aist.InPort("C_Poz6", self._d_C_Poz6)
		self._d_C_Poz7 = RTC.TimedPose2D(RTC.Time(0,0),RTC.Pose2D(RTC.Point2D(0,0), 0))
		"""
		"""
		self._C_Poz7In = OpenRTM_aist.InPort("C_Poz7", self._d_C_Poz7)
		self._d_C_Poz8 = RTC.TimedPose2D(RTC.Time(0,0), RTC.Pose2D(RTC.Point2D(0,0), 0))
		"""
		"""
		self._C_Poz8In = OpenRTM_aist.InPort("C_Poz8", self._d_C_Poz8)
		self._d_ref_vel_1 = RTC.TimedVelocity2D(RTC.Time(0,0), RTC.Velocity2D(0.0,0.0,0.0))
		"""
		"""
		self._ref_vel_1Out = OpenRTM_aist.OutPort("ref_vel_1", self._d_ref_vel_1)
		self._d_ref_vel_2 = RTC.TimedVelocity2D(RTC.Time(0,0),RTC.Velocity2D(0,0,0))
		"""
		"""
		self._ref_vel_2Out = OpenRTM_aist.OutPort("ref_vel_2", self._d_ref_vel_2)
		self._d_ref_vel_3 = RTC.TimedVelocity2D(RTC.Time(0,0),RTC.Velocity2D(0,0,0))
		"""
		"""
		self._ref_vel_3Out = OpenRTM_aist.OutPort("ref_vel_3", self._d_ref_vel_3)
		self._d_ref_vel_4 = RTC.TimedVelocity2D(RTC.Time(0,0),RTC.Velocity2D(0,0,0))
		"""
		"""
		self._ref_vel_4Out = OpenRTM_aist.OutPort("ref_vel_4", self._d_ref_vel_4)
		self._d_ref_vel_5 = RTC.TimedVelocity2D(RTC.Time(0,0),RTC.Velocity2D(0,0,0))
		"""
		"""
		self._ref_vel_5Out = OpenRTM_aist.OutPort("ref_vel_5", self._d_ref_vel_5)
		self._d_ref_vel_6 = RTC.TimedVelocity2D(RTC.Time(0,0),RTC.Velocity2D(0,0,0))
		"""
		"""
		self._ref_vel_6Out = OpenRTM_aist.OutPort("ref_vel_6", self._d_ref_vel_6)
		self._d_ref_vel_7 = RTC.TimedVelocity2D(RTC.Time(0,0),RTC.Velocity2D(0,0,0))
		"""
		"""
		self._ref_vel_7Out = OpenRTM_aist.OutPort("ref_vel_7", self._d_ref_vel_7)
		self._d_ref_vel_8 = RTC.TimedVelocity2D(RTC.Time(0,0),RTC.Velocity2D(0,0,0))
		"""
		"""
		self._ref_vel_8Out = OpenRTM_aist.OutPort("ref_vel_8", self._d_ref_vel_8)

		self._d_PozeSet = RTC.TimedPose2D(RTC.Time(0,0), RTC.Pose2D(RTC.Point2D(0,0), 0)) 
		self._PozeSetOut = OpenRTM_aist.OutPort("PozeSet", self._d_PozeSet)


		


		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	##
	#
	# The initialize action (on CREATED->ALIVE transition)
	# formaer rtc_init_entry() 
	# 
	# @return RTC::ReturnCode_t
	# 
	#
	def onInitialize(self):
		# Bind variables and configuration variable
		
		# Set InPort buffers
		self.addInPort("trigger",self._triggerIn)
		self.addInPort("C_Poz1",self._C_Poz1In)
		self.addInPort("C_Poz2",self._C_Poz2In)
		self.addInPort("C_Poz3",self._C_Poz3In)
		self.addInPort("C_Poz4",self._C_Poz4In)
		self.addInPort("C_Poz5",self._C_Poz5In)
		self.addInPort("C_Poz6",self._C_Poz6In)
		self.addInPort("C_Poz7",self._C_Poz7In)
		self.addInPort("C_Poz8",self._C_Poz8In)
		
		# Set OutPort buffers
		self.addOutPort("ref_vel_1",self._ref_vel_1Out)
		self.addOutPort("ref_vel_2",self._ref_vel_2Out)
		self.addOutPort("ref_vel_3",self._ref_vel_3Out)
		self.addOutPort("ref_vel_4",self._ref_vel_4Out)
		self.addOutPort("ref_vel_5",self._ref_vel_5Out)
		self.addOutPort("ref_vel_6",self._ref_vel_6Out)
		self.addOutPort("ref_vel_7",self._ref_vel_7Out)
		self.addOutPort("ref_vel_8",self._ref_vel_8Out)
		self.addOutPort("PozeSet", self._PozeSetOut)
		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		
		return RTC.RTC_OK
	
	#	##
	#	# 
	#	# The finalize action (on ALIVE->END transition)
	#	# formaer rtc_exiting_entry()
	#	# 
	#	# @return RTC::ReturnCode_t
	#
	#	# 
	#def onFinalize(self):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The startup action when ExecutionContext startup
	#	# former rtc_starting_entry()
	#	# 
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The shutdown action when ExecutionContext stop
	#	# former rtc_stopping_entry()
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
		##
		#
		# The activated action (Active state entry action)
		# former rtc_active_entry()
		#
		# @param ec_id target ExecutionContext Id
		# 
		# @return RTC::ReturnCode_t
		#
		#
	def onActivated(self, ec_id):
		self.Distance = 0
		self.Theta = 0
		self.X = 0
		self.Y = 0
		while self._C_Poz1In.isNew():
			self._C_Poz1In.read()
		while self._C_Poz3In.isNew():
			self._C_Poz1In.read()
		self._d_PozeSet = RTC.TimedPose2D(RTC.Time(0,0), RTC.Pose2D(RTC.Point2D(0,0), 0)) 
		self._PozeSetOut.write()
	
		return RTC.RTC_OK
	
		##
		#
		# The deactivated action (Active state exit action)
		# former rtc_active_exit()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onDeactivated(self, ec_id):
	
		return RTC.RTC_OK
	
		##
		#
		# The execution action that is invoked periodically
		# former rtc_active_do()
		#
		# @param ec_id target ExecutionContext Id
		#
		# @return RTC::ReturnCode_t
		#
		#
	def onExecute(self, ec_id):
		new_data = False
		#if (self._C_Poz1In.isNew() and self._C_Poz2In.isNew()):
		if (self._triggerIn.isNew()):
			new_data = True
			self._d_trigger = self._triggerIn.read()
			self.Distance = 0
			self.Theta = 0
		if (self._C_Poz1In.isNew()):
			new_data = True
			self._d_C_Poz1 = self._C_Poz1In.read()
		if (self._C_Poz2In.isNew()):
			new_data = True
			self._d_C_Poz2 = self._C_Poz2In.read()
		if (self._C_Poz3In.isNew()):
			new_data = True
			self._d_C_Poz3 = self._C_Poz2In.read()
		if (self._C_Poz4In.isNew()):
			new_data = True
			self._d_C_Poz4 = self._C_Poz2In.read()
		if (self._C_Poz5In.isNew()):
			new_data = True
			self._d_C_Poz5 = self._C_Poz2In.read()
		if (self._C_Poz6In.isNew()):
			new_data = True
			self._d_C_Poz6 = self._C_Poz2In.read()
		if (self._C_Poz7In.isNew()):
			new_data = True
			self._d_C_Poz7 = self._C_Poz2In.read()
		if (self._C_Poz8In.isNew()):
			new_data = True
			self._d_C_Poz8 = self._C_Poz2In.read()

		if not new_data:
			self._ref_vel_1Out.write()
			return RTC.RTC_OK

			#x = self._d_C_Poz1.data.position.x
			#y = self._d_C_Poz1.data.position.y
			#distance = math.sqrt((x-X)**2 + (y-Y)**2)
			#Distance = Distance + distance
		
		#print self._d_trigger.data
		#print self._d_trigger
		#if self._d_trigger.data == 1:
		if self._d_trigger.data == 1: #The smallest Hanabi
			#print "\n"
			#print self._d_C_Poz1
			#print self._d_C_Poz1.data
			print "heading"
			print self._d_C_Poz1.data.heading
			print "position"
			print self._d_C_Poz1.data.position
			#print self._d_C_Poz1.data.position.x
			print "ref_vel_1.data"
			print self._d_ref_vel_1.data
			x = self._d_C_Poz1.data.position.x
			y = self._d_C_Poz1.data.position.y
			self.Theta = self._d_C_Poz1.data.heading 
			distance = math.sqrt((x-self.X)**2 + (y-self.Y)**2)
			#distance = math.sqrt((x)**2 + (y)**2)

			print ("distance{0}".format(distance))
			self.Distance = self.Distance + distance
			#print ("self.Distance = {0}" .format(self.Distance))
			print ("Theta = {0}" .format(self.Theta))
			if self.Distance < 1.5:
			#if 1 < 2:
				self._d_ref_vel_1.data.vx = 0.1
				self._d_ref_vel_2.data.vx = 0.1
				self._d_ref_vel_3.data.vx = 0.0
				self._d_ref_vel_4.data.vx = 0.0
				self._d_ref_vel_5.data.vx = 0.0
				self._d_ref_vel_6.data.vx = 0.0
				self._d_ref_vel_7.data.vx = 0.0
				self._d_ref_vel_8.data.vx = 0.0
			elif self.Distance < 3.0: 
				self._d_ref_vel_1.data.vx = -0.1
				self._d_ref_vel_2.data.vx = -0.1
				self._d_ref_vel_3.data.vx = -0.0
				self._d_ref_vel_4.data.vx = -0.0
				self._d_ref_vel_5.data.vx = -0.0
				self._d_ref_vel_6.data.vx = -0.0
				self._d_ref_vel_7.data.vx = -0.0
				self._d_ref_vel_8.data.vx = -0.0
			else:
				self._d_ref_vel_1.data.vx = -0.0
				self._d_ref_vel_2.data.vx = -0.0
				self._d_ref_vel_3.data.vx = -0.0
				self._d_ref_vel_4.data.vx = -0.0
				self._d_ref_vel_5.data.vx = -0.0
				self._d_ref_vel_6.data.vx = -0.0
				self._d_ref_vel_7.data.vx = -0.0
				self._d_ref_vel_8.data.vx = -0.0


		elif self._d_trigger.data == 2:
			#print "\n"
			#print self._d_C_Poz1
			#print self._d_C_Poz1.data
			print "heading"
			print self._d_C_Poz1.data.heading
			print "position"
			print self._d_C_Poz1.data.position
			#print self._d_C_Poz1.data.position.x
			print "ref_vel_1.data"
			print self._d_ref_vel_1.data
			x = self._d_C_Poz1.data.position.x
			y = self._d_C_Poz1.data.position.y
			self.Theta = self._d_C_Poz1.data.heading 
			distance = math.sqrt((x-self.X)**2 + (y-self.Y)**2)
			self.Distance = self.Distance + distance
			#Theta = Theta + a
			print ("distance = {0}" .format(distance))
			print ("self.Distance = {0}" .format(self.Distance))
			print ("Theta = {0}" .format(self.Theta))
			if self.Distance < 1.0:
			#if 1 < 2:
				self._d_ref_vel_1.data.vx = 0.1
				self._d_ref_vel_2.data.vx = 0.1
				self._d_ref_vel_3.data.vx = 0.0
				self._d_ref_vel_4.data.vx = 0.0
				self._d_ref_vel_5.data.vx = 0.0
				self._d_ref_vel_6.data.vx = 0.0
				self._d_ref_vel_7.data.vx = 0.0
				self._d_ref_vel_8.data.vx = 0.0
			elif self.Distance >= 1.0 and self.Distance < 2.0 and self.Theta > -0.8 and self.Theta < 0.8:
				self._d_ref_vel_1.data.vx = 0.1
				self._d_ref_vel_1.data.va= 0.5 
				self._d_ref_vel_2.data.vx = 0.1 
				self._d_ref_vel_2.data.va= -0.5
				self._d_ref_vel_3.data.vx = 0.0 
				self._d_ref_vel_3.data.va= 0.0
				self._d_ref_vel_4.data.vx = 0.0 
				self._d_ref_vel_4.data.va= 0.0
				self._d_ref_vel_5.data.vx = 0.0 
				self._d_ref_vel_5.data.va= 0.0
				self._d_ref_vel_6.data.vx = 0.0 
				self._d_ref_vel_6.data.va= 0.0
				self._d_ref_vel_7.data.vx = 0.0 
				self._d_ref_vel_7.data.va= 0.0
				self._d_ref_vel_8.data.vx = 0.0 
				self._d_ref_vel_8.data.va= 0.0
			elif self.Distance < 2.0:
				self._d_ref_vel_1.data.vx = 0.2 
				self._d_ref_vel_1.data.va= 0.0
				self._d_ref_vel_2.data.vx = 0.2 
				self._d_ref_vel_2.data.va= 0.0
				self._d_ref_vel_3.data.vx = 0.0 
				self._d_ref_vel_3.data.va= 0.0
				self._d_ref_vel_4.data.vx = 0.0 
				self._d_ref_vel_4.data.va= 0.0
				self._d_ref_vel_5.data.vx = 0.0 
				self._d_ref_vel_5.data.va= 0.0
				self._d_ref_vel_6.data.vx = 0.0 
				self._d_ref_vel_6.data.va= 0.0
				self._d_ref_vel_7.data.vx = 0.0 
				self._d_ref_vel_7.data.va= 0.0
				self._d_ref_vel_8.data.vx = 0.1 
				self._d_ref_vel_8.data.va= 0.0
		#	elif self.Distance < 1.5:
		#		self._d_ref_vel_1.data.vx = -0.2 
		#		self._d_ref_vel_1.data.va= 0.0
		#		self._d_ref_vel_2.data.vx = -0.2 
		#		self._d_ref_vel_2.data.va= 0.0
		#		self._d_ref_vel_3.data.vx = 0.1 
		#		self._d_ref_vel_3.data.va= 0.0
		#		self._d_ref_vel_4.data.vx = 0.1 
		#		self._d_ref_vel_4.data.va= 0.0
		#		self._d_ref_vel_5.data.vx = 0.1 
		#		self._d_ref_vel_5.data.va= 0.0
		#		self._d_ref_vel_6.data.vx = 0.1 
		#		self._d_ref_vel_6.data.va= 0.0
		#		self._d_ref_vel_7.data.vx = 0.1 
		#		self._d_ref_vel_7.data.va= 0.0
		#		self._d_ref_vel_8.data.vx = 0.1 
		#		self._d_ref_vel_8.data.va= 0.0

		#	elif self.Distance >= 1.5 and self.Theta > 0:
		#		self._d_ref_vel_1.data.vx = -0.1 
		#		self._d_ref_vel_1.data.va= -0.5
		#		self._d_ref_vel_2.data.vx = -0.1 
		#		self._d_ref_vel_2.data.va= 0.5
		#		self._d_ref_vel_3.data.vx = 0.1 
		#		self._d_ref_vel_3.data.va= 0.0
		#		self._d_ref_vel_4.data.vx = 0.1 
		#		self._d_ref_vel_4.data.va= 0.0
		#		self._d_ref_vel_5.data.vx = 0.1 
		#		self._d_ref_vel_5.data.va= 0.0
		#		self._d_ref_vel_6.data.vx = 0.1 
		#		self._d_ref_vel_6.data.va= 0.0
		#		self._d_ref_vel_7.data.vx = 0.1 
		#		self._d_ref_vel_7.data.va= 0.0
		#		self._d_ref_vel_8.data.vx = 0.1 
		#		self._d_ref_vel_8.data.va= 0.0
		#	elif self.Distance < 2.0:
		#		self._d_ref_vel_1.data.vx = -0.1 
		#		self._d_ref_vel_1.data.va= 0.0
		#		self._d_ref_vel_2.data.vx = -0.1 
		#		self._d_ref_vel_2.data.va= 0.0
		#		self._d_ref_vel_3.data.vx = 0.1 
		#		self._d_ref_vel_3.data.va= 0.0
		#		self._d_ref_vel_4.data.vx = 0.1 
		#		self._d_ref_vel_4.data.va= 0.0
		#		self._d_ref_vel_5.data.vx = 0.1 
		#		self._d_ref_vel_5.data.va= 0.0
		#		self._d_ref_vel_6.data.vx = 0.1 
		#		self._d_ref_vel_6.data.va= 0.0
		#		self._d_ref_vel_7.data.vx = 0.1 
		#		self._d_ref_vel_7.data.va= 0.0
		#		self._d_ref_vel_8.data.vx = 0.1 
		#		self._d_ref_vel_8.data.va= 0.0
			else: 
				self._d_ref_vel_1.data.vx = 0.0 
				self._d_ref_vel_1.data.va= 0.0
				self._d_ref_vel_2.data.vx = 0.0 
				self._d_ref_vel_2.data.va= 0.0
				self._d_ref_vel_3.data.vx = 0.0 
				self._d_ref_vel_3.data.va= 0.0
				self._d_ref_vel_4.data.vx = 0.0 
				self._d_ref_vel_4.data.va= 0.0
				self._d_ref_vel_5.data.vx = 0.0 
				self._d_ref_vel_5.data.va= 0.0
				self._d_ref_vel_6.data.vx = 0.0 
				self._d_ref_vel_6.data.va= 0.0
				self._d_ref_vel_7.data.vx = 0.0 
				self._d_ref_vel_7.data.va= 0.0
				self._d_ref_vel_8.data.vx = 0.0 
				self._d_ref_vel_8.data.va= 0.0
		elif self._d_trigger.data == 3:
		#else: #Pattern3-The Greatest 
			#print "\n"
			#print self._d_C_Poz1
			#print self._d_C_Poz1.data
			print "Now using the largest Hanabi Pattern"
			print "heading"
			print self._d_C_Poz1.data.heading
			print "position"
			print self._d_C_Poz1.data.position
			#print self._d_C_Poz1.data.position.x
			print "ref_vel_1.data"
			print self._d_ref_vel_1.data
			x = self._d_C_Poz1.data.position.x
			y = self._d_C_Poz1.data.position.y
			self.Theta = self._d_C_Poz1.data.heading 
			distance = math.sqrt((x-self.X)**2 + (y-self.Y)**2)
			self.Distance = self.Distance + distance
			#Theta = Theta + a
			print ("self.Distance = {0}" .format(self.Distance))
			print ("Theta = {0}" .format(self.Theta))
			if self.Distance < 1.0:
			#if 1 < 2:
				self._d_ref_vel_1.data.vx = 0.1
				self._d_ref_vel_2.data.vx = 0.1
				self._d_ref_vel_3.data.vx = 0.1
				self._d_ref_vel_4.data.vx = 0.1
				self._d_ref_vel_5.data.vx = 0.1
				self._d_ref_vel_6.data.vx = 0.1
				self._d_ref_vel_7.data.vx = 0.1
				self._d_ref_vel_8.data.vx = 0.1
			elif self.Distance >= 1.0 and self.Theta > -0.3 and self.Theta < 0.3:
				self._d_ref_vel_1.data.vx = 0.1 
				self._d_ref_vel_1.data.va= 0.1
				self._d_ref_vel_2.data.vx = 0.1 
				self._d_ref_vel_2.data.va= -0.1
				self._d_ref_vel_3.data.vx = 0.1 
				self._d_ref_vel_3.data.va= 0.5
				self._d_ref_vel_4.data.vx = 0.1 
				self._d_ref_vel_4.data.va= -0.5
				self._d_ref_vel_5.data.vx = 0.1 
				self._d_ref_vel_5.data.va= -0.5
				self._d_ref_vel_6.data.vx = 0.1 
				self._d_ref_vel_6.data.va= 0.5
				self._d_ref_vel_7.data.vx = 0.1 
				self._d_ref_vel_7.data.va= -0.5
				self._d_ref_vel_8.data.vx = 0.1 
				self._d_ref_vel_8.data.va= 0.1
			elif self.Distance < 2.0:
				self._d_ref_vel_1.data.vx = 0.2 
				self._d_ref_vel_1.data.va= 0.0
				self._d_ref_vel_2.data.vx = 0.2 
				self._d_ref_vel_2.data.va= 0.0
				self._d_ref_vel_3.data.vx = 0.2 
				self._d_ref_vel_3.data.va= 0.0
				self._d_ref_vel_4.data.vx = 0.2 
				self._d_ref_vel_4.data.va= 0.0
				self._d_ref_vel_5.data.vx = -0.2 
				self._d_ref_vel_5.data.va= 0.0
				self._d_ref_vel_6.data.vx = -0.2 
				self._d_ref_vel_6.data.va= 0.0
				self._d_ref_vel_7.data.vx = -0.2 
				self._d_ref_vel_7.data.va= 0.0
				self._d_ref_vel_8.data.vx = -0.2 
				self._d_ref_vel_8.data.va= 0.0
			else: 
				self._d_ref_vel_1.data.vx = 0.0 
				self._d_ref_vel_1.data.va= 0.0
				self._d_ref_vel_2.data.vx = 0.0 
				self._d_ref_vel_2.data.va= 0.0
				self._d_ref_vel_3.data.vx = 0.0 
				self._d_ref_vel_3.data.va= 0.0
				self._d_ref_vel_4.data.vx = 0.0 
				self._d_ref_vel_4.data.va= 0.0
				self._d_ref_vel_5.data.vx = 0.0 
				self._d_ref_vel_5.data.va= 0.0
				self._d_ref_vel_6.data.vx = 0.0 
				self._d_ref_vel_6.data.va= 0.0
				self._d_ref_vel_7.data.vx = 0.0 
				self._d_ref_vel_7.data.va= 0.0
				self._d_ref_vel_8.data.vx = 0.0 
				self._d_ref_vel_8.data.va= 0.0


			self.X = x
			self.Y = y
		print ("current state is {0}" .format(self._d_trigger.data)) 
		self._ref_vel_1Out.write()
		self._ref_vel_2Out.write()
		self._ref_vel_3Out.write()
		self._ref_vel_4Out.write()
		self._ref_vel_5Out.write()
		self._ref_vel_6Out.write()
		self._ref_vel_7Out.write()
		self._ref_vel_8Out.write()
		return RTC.RTC_OK
	
	#	##
	#	#
	#	# The aborting action when main logic error occurred.
	#	# former rtc_aborting_entry()
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onAborting(self, ec_id):
	#		else: 
	#			self._d_ref_vel_1.data.vx = 0.0 
	#			self._d_ref_vel_1.data.va= 0.0
	#		X = x
	#		Y = y
	#		self._ref_vel_1Out.write()
	#		self._ref_vel_2Out.write()
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The aborting action when main logic error occurred.
	#	# former rtc_aborting_entry()
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The error action in ERROR state
	#	# former rtc_error_do()
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The reset action that is invoked resetting
	#	# This is same but different the former rtc_init_entry()
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The state update action that is invoked after onExecute() action
	#	# no corresponding operation exists in OpenRTm-aist-0.2.0
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#

	#	#
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#	##
	#	#
	#	# The action that is invoked when execution context's rate is changed
	#	# no corresponding operation exists in OpenRTm-aist-0.2.0
	#	#
	#	# @param ec_id target ExecutionContext Id
	#	#
	#	# @return RTC::ReturnCode_t
	#	#
	#	#
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	



def HanabigeneratorInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=hanabigenerator_spec)
    manager.registerFactory(profile,
                            Hanabigenerator,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    HanabigeneratorInit(manager)

    # Create a component
    comp = manager.createComponent("Hanabigenerator")

def main():
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager()

if __name__ == "__main__":
	main()

