// -*- C++ -*-
/*!
 * @file  LEDcolor_11.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "LEDcolor_11.h"
#include "math.h"
double X=0;
double Y=0;
double D=0;

// Module specification
// <rtc-template block="module_spec">
static const char* ledcolor_11_spec[] =
  {
    "implementation_id", "LEDcolor_11",
    "type_name",         "LEDcolor_11",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "VenderName",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
LEDcolor_11::LEDcolor_11(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_currentposeIn("currentpose", m_currentpose),
    m_digitaloutOut("digitalout", m_digitalout)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
LEDcolor_11::~LEDcolor_11()
{
}



RTC::ReturnCode_t LEDcolor_11::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("currentpose", m_currentposeIn);
  
  // Set OutPort buffer
  addOutPort("digitalout", m_digitaloutOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t LEDcolor_11::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t LEDcolor_11::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t LEDcolor_11::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t LEDcolor_11::onActivated(RTC::UniqueId ec_id)
{
	X=0;
	Y=0;
	d=0;

	m_digitalout.data.length(3);
	m_digitalout.data[0] = 0;
	m_digitalout.data[1] = 0;
	m_digitalout.data[2] = 0;

  return RTC::RTC_OK;
}


RTC::ReturnCode_t LEDcolor_11::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t LEDcolor_11::onExecute(RTC::UniqueId ec_id)
{
	if(m_currentposeIn.isNew())
	{
		m_currentposeIn.read();
		double x=m_currentpose.data.position.x*1000;
	    	double y=m_currentpose.data.position.y*1000;
	    	double d=sqrt((x-X)*(x-X)+(y-Y)*(y-Y))+D;

		std::cout<<"x = "<<x <<std::endl;
		std::cout<<"y = "<<y <<std::endl;
		std::cout<<"d = "<<d <<std::endl;
        
		if(800>=d && d >10)
		{
			j=1;
		}
		else if(1100>=d && d>800)
		{
			j=2;
		}
		else if(1300>=d && d>1100)
		{
			j=3;
		}
		else if(1500>=d && d>1300)
		{
			j=4;
		}
		else if(d>1500 && x<50 && -50<x)
		{
			j=7;
		}
		else
		{
			j=0;
		}
	
		switch(j)
		{
			case 1://yellow
//				   m_digitalout.data.length(3);
				   m_digitalout.data[0] = 1.0;
				   m_digitalout.data[1] = 1.0;
				   m_digitalout.data[2] = 0.0;
				   break;
			case 2://red
//				   m_digitalout.data.length(3);
				   m_digitalout.data[0] = 1.0;
				   m_digitalout.data[1] = 0.0;
				   m_digitalout.data[2] = 0.0;
				   break;
			case 3://purple
//				   m_digitalout.data.length(3);
				   m_digitalout.data[0] = 1.0;
				   m_digitalout.data[1] = 0.0;
				   m_digitalout.data[2] = 0.5;
				   break;
			case 4://blue
//				   m_digitalout.data.length(3);
				   m_digitalout.data[0] = 0.0;
				   m_digitalout.data[1] = 0.0;
				   m_digitalout.data[2] = 1.0;
				   break;
			case 5://
//				   m_digitalout.data.length(3);
				   m_digitalout.data[0] = 0;
				   m_digitalout.data[1] = 1.0;
				   m_digitalout.data[2] = 1.0;
				   break;
			case 7://reset
				   x=0;
				   y=0;
				   d=0;
				   break;
			default://black
				   m_digitalout.data.length(3);
				   m_digitalout.data[0] = 0;
				   m_digitalout.data[1] = 0;
				   m_digitalout.data[2] = 0;
				   break;
	   }
	    	X=x;
		Y=y;
		D=d;
		std::cout<< m_digitalout.data[0] << " " << m_digitalout.data[1] << " " <<  m_digitalout.data[2] << std::endl;
				   m_digitaloutOut.write();

	}
	return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t LEDcolor_11::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t LEDcolor_11::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t LEDcolor_11::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t LEDcolor_11::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t LEDcolor_11::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void LEDcolor_11Init(RTC::Manager* manager)
  {
    coil::Properties profile(ledcolor_11_spec);
    manager->registerFactory(profile,
                             RTC::Create<LEDcolor_11>,
                             RTC::Delete<LEDcolor_11>);
  }
  
};


